package com.emdoor.scanbcdemo;

import androidx.appcompat.app.AppCompatActivity;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.view.View;
import android.widget.TextView;
import android.widget.ToggleButton;

public class MainActivity extends AppCompatActivity {
    // Receive QR code and bar code data action and extra
    public static final String BARCODEPORT_RECEIVEDDATA_ACTION = "com.android.serial.BARCODEPORT_RECEIVEDDATA_ACTION";
    public static final String BARCODEPORT_RECEIVEDDATA_EXTRA_DATA = "DATA";

    // Simulate scan keys
    static public final String ACTION_KEYEVENT_KEYCODE_SCAN_L_DOWN = "com.android.action.keyevent.KEYCODE_KEYCODE_SCAN_L_DOWN";
    static public final String ACTION_KEYEVENT_KEYCODE_SCAN_L_UP = "com.android.action.keyevent.KEYCODE_KEYCODE_SCAN_L_UP";
    static public final String ACTION_KEYEVENT_KEYCODE_SCAN_R_DOWN = "com.android.action.keyevent.KEYCODE_KEYCODE_SCAN_R_DOWN";
    static public final String ACTION_KEYEVENT_KEYCODE_SCAN_R_UP = "com.android.action.keyevent.KEYCODE_KEYCODE_SCAN_R_UP";
    public static final String ACTION_KEYEVENT_SCAN_F_UP = "com.android.action.keyevent.KEYCODE_KEYCODE_SCAN_F_UP";
    public static final String ACTION_KEYEVENT_SCAN_F_DOWN = "com.android.action.keyevent.KEYCODE_KEYCODE_SCAN_F_DOWN";

    BroadcastReceiver receiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            ((ToggleButton) findViewById(R.id.b_scan)).setChecked(false);
            String data = intent.getStringExtra(BARCODEPORT_RECEIVEDDATA_EXTRA_DATA);   // get data from intent
            if (data != null && data.length() > 0) {
                ((TextView) findViewById(R.id.tv_show)).append(data + "\r\n");          // show data
            }
        }
    };

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        // Simulate scan key press and release while touch the button on screen.
        findViewById(R.id.b_scan).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                String action = ((ToggleButton) findViewById(R.id.b_scan)).isChecked() ?
                        ACTION_KEYEVENT_KEYCODE_SCAN_L_DOWN :                               // trigger scan action
                        ACTION_KEYEVENT_KEYCODE_SCAN_L_UP;                                  // stop scan action
                Intent intent = new Intent(action);
                sendBroadcast(intent);
            }
        });
        // Register QR code and bar code data receiver.
        IntentFilter filter = new IntentFilter(BARCODEPORT_RECEIVEDDATA_ACTION);
        registerReceiver(receiver, filter);
    }

    @Override
    protected void onDestroy() {
        unregisterReceiver(receiver);
        super.onDestroy();
    }
}
